<template>
    <div class="_consume">
        <HeadlineTag value="温度环测数据"></HeadlineTag>
        <div class="_consume_mains" v-if="resultData && Object.keys(resultData).length != 0">
            <div ref="chartRef" style="width: 100%; height: 100%;"></div>
        </div>
        <Empty :bottom="true" v-else></Empty>
    </div>
</template>

<script setup>
import { ref, onMounted, onUnmounted, nextTick } from 'vue';
import * as echarts from 'echarts';
import HeadlineTag from '@/components/HeadlineTag';
import Empty from '@/components/Empty'
const props = defineProps({
    resultData: {
        type: Object,
        default: {}
    }
})

const chartRef = ref(null);
let chart = null;
const generateRandomData = (length, max) => {
    const randomData = [];
    for (let i = 0; i < length; i++) {
        randomData.push(Math.floor(Math.random() * max));
    }
    return randomData;
};
const handleResize = () => {
    if (chart) {
        chart.resize();
    }
};
onMounted(() => {
    initChart();
});
const initChart = (dates, EPE) => {
    if (chartRef.value) {
        chart = echarts.init(chartRef.value);
        // 修改为 24 小时
        // const hours = Array.from({ length: 24 }, (_, i) => `${i}时`);
        const hours = dates
        const option = {
            xAxis: {
                type: 'category',
                // 使用 24 小时数据
                data: hours,
                axisLabel: {
                    color: '#fff'
                },
            },
            tooltip: {
                trigger: 'axis',
                axisPointer: {
                    type: 'cross',
                    crossStyle: {
                        color: '#999'
                    }
                },
                textStyle: {
                    color: '#fafafa',
                },
                borderColor: 'transparent',
                backgroundColor: 'rgba(0, 0, 0, 0.5)',
                extraCssText: 'backdrop-filter: blur(6px);',
            },
            grid: {
                top: '10%',
                bottom: '10%',
                right: '0%',
            },
            yAxis: {
                type: 'value',
                axisLabel: {
                    show: true,
                    color: '#fff'
                },
                splitLine: {
                    show: false,
                    lineStyle: {
                        color: '#44585e'
                    }
                },
                axisTick: {
                    show: false
                },
            },
            series: [
                {
                    name: '温度',
                    // data: generateRandomData(7, 50),
                    data: EPE,
                    type: 'line',
                    showSymbol: false,
                    smooth: true,
                    color: '#f5c400',
                    lineStyle: {
                        width: 2,
                    },
                    areaStyle: {
                        color: new echarts.graphic.LinearGradient(
                            0,
                            0,
                            0,
                            1,
                            [{
                                offset: 0,
                                color: 'rgba(245, 196, 0, .6)',
                            },
                            {
                                offset: 0.8,
                                color: 'rgba(245, 196, 0, .2)',
                            },
                            ],
                            false
                        ),
                        shadowColor: 'rgba(0, 0, 0, 0.1)',
                        shadowBlur: 10,
                    },
                    symbol: 'circle',
                    symbolSize: 6,
                }
            ]
        };

        chart.setOption(option);
    }
}

watch(() => props.resultData, (newVal) => {
    if (newVal) {
        if (newVal && chart == null) {
            nextTick(() => {
                initChart(Object.keys(newVal), Object.entries(newVal));
            });
        }
        if (chart) {
            chart.setOption({
                xAxis: {
                    data: Object.keys(newVal),
                },
                series: [{
                    type: 'line',
                    data: Object.entries(newVal),
                }],
            })
        }
    }
}, { deep: true, immediate: true } // 开启深度监听
)
onUnmounted(() => {
    window.removeEventListener('resize', handleResize);
    if (chart) {
        chart.dispose();
    }
});
</script>

<style lang="scss">
._divider {
    height: 1px;
    border: 1px dashed #168cdb;
    flex: 1;
    margin: 0 10px;
}

._consume {
    display: flex;
    flex-direction: column;

    &_mains {
        margin: 10px 30px;
        flex: 1;
        display: flex;

        &_item {
            display: flex;
            justify-content: space-between;
            align-items: center;
            padding: 10px;

            &_name {
                width: 30px;
                height: 30px;
                background: url("@/assets/images/content_circle_num.png");
                background-size: 100% 100%;
                background-position: center;
                background-repeat: no-repeat;
                // animation: scanning 4s linear infinite;
                border: 1px solid red;
            }

            &_flag {
                display: flex;
                align-items: center;
                gap: 3px;

                &_item {
                    width: 30px;
                    height: 30px;
                    border: 3px dashed #168cdb;
                    box-sizing: border-box;
                    background: #0e6ead;
                    color: #fff;
                    border-radius: 50%;
                    display: flex;
                    align-items: center;
                    justify-content: center;
                    font-size: 14px;
                }
            }
        }

        &_item:hover {
            cursor: pointer;
            background-image: linear-gradient(to right, #168cdb, transparent);
        }
    }
}
</style>